from flask import Flask, render_template, request, jsonify, session
from IAIS_llm import llm
import os
import json
import time
import logging

# Initialize Flask app
app = Flask(__name__)
app.secret_key = os.getenv("SECRET_KEY", "default_secret_key")

# Configure paths and constants
CONVERSATION_DIR = os.path.join(os.getenv("SHARED_FOLDER_PATH", "."), "conversations")
os.makedirs(CONVERSATION_DIR, exist_ok=True)
MAX_CONTEXT_LENGTH = 10000

# Configure logging
logging.basicConfig(
    level=logging.INFO,
    format="%(asctime)s - %(name)s - %(levelname)s - %(message)s"
)
logger = logging.getLogger(__name__)

def check_context_length(history):
    """
    Ensures the conversation history does not exceed the maximum context length.
    Resets the context if the limit is exceeded.
    """
    if len(history) > MAX_CONTEXT_LENGTH:
        logger.warning("Conversation history exceeds max length. Resetting context.")
        return "Context reset due to length limit. Starting fresh.\n"
    return history

@app.route("/")
def index():
    session.clear()
    logger.info("Rendering home page.")
    return render_template("index.html", model_name="{{ model_name }}")

@app.route("/invoke_llm", methods=["POST"])
def invoke_llm():
    prompt = request.json.get("prompt", "")
    if not prompt:
        logger.error("Prompt is missing in the request.")
        return jsonify({"error": "Prompt is required"}), 400

    # Update conversation history
    conversation_history = session.get("conversation_history", "") + f"\nUser: {prompt}\n"
    conversation_history = check_context_length(conversation_history)

    model_platform = "{{ model_platform }}"
    try:
        if model_platform == "GenAI-LLM-Hosting":
            response_text = invoke_genai_llm(conversation_history)
        elif model_platform == "Individual-OpenAI":
            response_text = invoke_openai_llm(conversation_history)
        elif model_platform == "IONOS-DGX":
            response_text = invoke_dgx_llm(conversation_history)        
        else:
            logger.error(f"Invalid model platform: {model_platform}")
            return jsonify({"error": "Invalid model platform"}), 400
    
        # Update session with conversation history
        session["conversation_history"] = conversation_history + "\n" + response_text
        logger.info("LLM invocation successful. Returning response.")
        return jsonify({"response": response_text})

    except Exception as e:
        logger.exception(f"Error invoking LLM: {e}")
        return jsonify({"error": "Error processing request"}), 500

def invoke_genai_llm(history):
    try:
        response = llm.invoke(history)
        logger.info("GenAI-LLM-Hosting invocation successful.")
        return response
    except Exception as e:
        logger.exception(f"Error invoking GenAI-LLM-Hosting: {e}")
        return "Error invoking GenAI LLM."

def invoke_dgx_llm(history):
    """
    Function to invoke the LLM on DGX-LLM-Hosting platform.
    """
    try:
        response = llm.invoke(history)
        logger.info("IONOX-LLM-Hosting invocation successful.")
        return response
    except Exception as e:
        logger.exception(f"Error invoking IONOX-LLM-Hosting: {e}")
        return "Error invoking DGX LLM."


def invoke_openai_llm(history):
    """
    Function to invoke the LLM on Individual-OpenAI platform.
    Transforms the conversation into the message format expected by OpenAI.
    """
    try:
        messages = [
            {"role": "system", "content": "You are a helpful assistant that answers queries."},
            {"role": "user", "content": history}
        ]
        response = llm.invoke(messages)
        logger.info("OpenAI invocation successful.")
        return response.content
    except Exception as e:
        logger.exception(f"Error invoking OpenAI LLM: {e}")
        return "Error invoking OpenAI LLM."

@app.route("/start_new_conversation", methods=["POST"])
def start_new_conversation():
    session.pop("conversation_history", None)
    logger.info("New conversation started.")
    return jsonify({"status": "New conversation started"})

@app.route("/save_conversation", methods=["POST"])
def save_conversation():
    history = session.get("conversation_history")
    if not history:
        logger.warning("No conversation to save.")
        return jsonify({"status": "No conversation to save"})

    filename = f"conversation_{int(time.time())}.json"
    file_path = os.path.join(CONVERSATION_DIR, filename)

    try:
        with open(file_path, "w") as file:
            json.dump({"history": history}, file, indent=2)
        logger.info(f"Conversation saved as {filename}.")
        return jsonify({"status": f"Conversation saved as {filename}"})
    except Exception as e:
        logger.exception(f"Error saving conversation: {e}")
        return jsonify({"error": str(e)}), 500

@app.route("/conversations", methods=["GET"])
def list_conversations():
    try:
        files = os.listdir(CONVERSATION_DIR)
        logger.info("Retrieved list of saved conversations.")
        return jsonify({"conversations": files})
    except Exception as e:
        logger.exception(f"Error listing conversations: {e}")
        return jsonify({"error": str(e)}), 500

@app.route("/conversations/<filename>", methods=["GET"])
def view_conversation(filename):
    file_path = os.path.join(CONVERSATION_DIR, filename)
    try:
        with open(file_path, "r") as file:
            logger.info(f"Viewing conversation: {filename}")
            return jsonify({"conversation": json.load(file)})
    except FileNotFoundError:
        logger.warning(f"Conversation file not found: {filename}")
        return jsonify({"error": "File not found"}), 404
    except Exception as e:
        logger.exception(f"Error viewing conversation: {e}")
        return jsonify({"error": str(e)}), 500

@app.route("/delete_conversation", methods=["POST"])
def delete_conversations():
    try:
        for file in os.listdir(CONVERSATION_DIR):
            os.remove(os.path.join(CONVERSATION_DIR, file))
        logger.info("All conversations deleted.")
        return jsonify({"status": "All conversations deleted"})
    except Exception as e:
        logger.exception(f"Error deleting conversations: {e}")
        return jsonify({"error": str(e)}), 500

def app_run():
    logger.info("Starting Flask app on port 8062.")
    app.run(host="0.0.0.0", port=8062, debug=True, use_reloader=False)
